/*
   LCD Keypad with 3 buttons and SD-Card
   Created by Lorenzo Cervelli - 2023
*/

// File DB per le voci-menu` del display
#include "DB.h";

// Impostazioni display
#include "LCDcode.h";

// Pulsanti
#define Bt_LEFT 5
#define Bt_RIGHT 4
#define Bt_UP 3
#define Bt_DOWN 2
#define Bt_SELECT 6
int lastState_LEFT = HIGH;
int lastState_RIGHT = HIGH;
int lastState_UP = HIGH;
int lastState_DOWN = HIGH;
int lastState_SELECT = HIGH;


void setup() 
{
    // Pulsanti
    pinMode(Bt_LEFT, INPUT_PULLUP);
    pinMode(Bt_RIGHT, INPUT_PULLUP);
    pinMode(Bt_UP, INPUT_PULLUP);
    pinMode(Bt_DOWN, INPUT_PULLUP);
    pinMode(Bt_SELECT, INPUT_PULLUP);

    // Impostazioni display
    SetupModule();

    // Menu` display
    ImpostaValori();
}

void loop() 
{
    int value_LEFT = digitalRead((Bt_LEFT));
    int value_RIGHT = digitalRead((Bt_RIGHT));
    int value_UP = digitalRead((Bt_UP));
    int value_DOWN = digitalRead((Bt_DOWN));
    int value_SELECT = digitalRead((Bt_SELECT));
    
    if (lastState_LEFT != value_LEFT) 
    {  
        if (value_LEFT==LOW)
        {
            Indietro();
        }

        lastState_LEFT = value_LEFT;
    }

    if (lastState_RIGHT != value_RIGHT) 
    {  
        if (value_RIGHT==LOW)
        {
            Avanti();
        }

        lastState_RIGHT = value_RIGHT;
    }

    if (lastState_UP != value_UP) 
    {  
        if (value_UP==LOW)
        {
            Serial.println("Up button pressed");
        }

        lastState_UP = value_UP;
    }

    if (lastState_DOWN != value_DOWN) 
    {
        if (value_DOWN==LOW)
        {
            Serial.println("Down button pressed");
        }

        lastState_DOWN = value_DOWN;
    }

    if (lastState_SELECT != value_SELECT) 
    {
        if (value_SELECT==LOW)
        {
            String Rt = Seleziona();
            Azione(Rt);
        }

        lastState_SELECT = value_SELECT;
    }   
}


void Azione(String Valore)
{
    Serial.println("Action to do:");

    String Final[3]; 
    int r=0, cnt=0;     
    for (int i=0; i < Valore.length(); i++)
    { 
        if(Valore.charAt(i) == ';') 
        { 
            String Rg = Valore.substring(r, i);
            Final[cnt]=Valore.substring(r, i);
            r=(i+1); 
            cnt++;
        }
    }

    Serial.println("Item: " + Final[0]);
    Serial.println("Row:" + Final[1]);
    Serial.println("Col:" + Final[2]);
    Serial.println("");

    // Example of action
    if (Final[0]=="6 > @ 6.2 > @ 6.2.2")
    {
        Serial.println("This is the action " + Final[0]);

        if (SelectedItems[Final[1].toInt()][Final[2].toInt()] == true)
        {
            // Imposto i valori delle selezioni dei menu` (Riga, Colonna)
            SelectedItems[Final[1].toInt()][Final[2].toInt()] = false;   
        }
        else
        {
            // Imposto i valori delle selezioni dei menu` (Riga, Colonna)
            SelectedItems[Final[1].toInt()][Final[2].toInt()] = true;   
        }   

        AggiornaDisplay();
    }
}